require(graphics); require(USPS)

#input the abciximab study data of Kereiakes et al. (2000).
data(lindner)
# outcomes: lifepres & cardbill

cat("\n UNSUPERVISED analyses...")

# Define Divisive Cluster Hierarchy for UNSUPERVISED analyses...
UPSxvars <- c("stent","height","female","diabetic","acutemi","ejecfrac","ves1proc")
UPSharch <- UPShclus(lindner, UPSxvars)
UPSharch

# Save UPSpars settings for NN/IV analyses of the "lifepres" outcome
UPSaccum(UPSharch, lindner, abcix, lifepres, faclev=1, accobj="ABClife")

lif001nn <- UPSnnltd(  1)
lif002nn <- UPSnnltd(  2)
lif005nn <- UPSnnltd(  5)
lif010nn <- UPSnnltd( 10)
lif020nn <- UPSnnltd( 20)	# average cluster size ~50 patients 
plot(lif020nn)  			# graphical display
lif020nn 					# console output
lif030nn <- UPSnnltd( 30)
lif040nn <- UPSnnltd( 40)	# average cluster size ~25 patients  
plot(lif040nn)  			# graphical display

lif050iv <- UPSivadj( 50)
plot(lif050iv)  # graphical display
lif100iv <- UPSivadj(100)
lif100iv 		# console output
lif200iv <- UPSivadj(200)
lif996iv <- UPSivadj(996)

# Overall "Sensitivity Analysis" Summary...
UPSgraph()

# Display contents of UPSdf...
ABClife

# Compare NN/LTD and Artificial LTD distributions for 20 clusters
abcdf <- UPSaltdd(lindner, abcix, lifepres, faclev=1, NNobj=lif020nn, reps=500)
abcdf
plot(abcdf)

cat("\n alternative SUPERVISED analyses...")

# Define Logit Model for Treatment Choice in SUPERVISED analyses
PStreat <- abcix~stent+height+female+diabetic+acutemi+ejecfrac+ves1proc
logtSPS <- SPSlogit(lindner, PStreat, PSfit, PSrnk, PSbin, appn="lindSPS")
# Store Propensity Score info (default=5 bins) in frame named "lindSPS"
logtSPS

# Testing for Within-Bin Balance on Continuous Covariate...
SPSbalvs <- SPSbalan(lindSPS, abcix, PSbin, ves1proc)
plot(SPSbalvs)
SPSbalvs

# Testing for Within-Bin Balance on Binary (Dichotomous) Covariate: Questionable Assumptions...
# SPSbalam <- SPSbalan(lindSPS, abcix, PSbin, acutemi)
# SPSbalam

# Test for Within-Bin Outcome Differences...
lindlife <- SPSoutco(lindSPS, abcix, PSbin, lifepres, faclev=1)
plot(lindlife)
lindlife

lindcost <- SPSoutco(lindSPS, abcix, PSbin, cardbill)
plot(lindcost) 
lindcost

# Cubic smoothing spline analyses...
SPScbill <- SPSsmoot(lindSPS, abcix, PSfit, cardbill)
plot(SPScbill)

# Loess "symmetric" smoothing analyses...
SPScblss <- SPSloess(lindSPS, abcix, PSfit, cardbill)
plot(SPScblss)